// 005 u_c_compiler_15
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

(*$r+*)

unit u_c_compiler_15;
  interface
    uses Classes;

    type c_compiler= class
                       Constructor create_compiler;
                       procedure compile(p_file_name: String; p_c_output: tStrings);
                       Destructor Destroy; Override;
                     end; // c_compiler

  implementation
    uses SysUtils, u_c_display
        , u_c_scanner_15
        , u_c_ast_tree_15
        , u_c_instruction_list_15
        , u_c_variable_list_15
        , u_c_parser_15

        , u_c_interpreter_15
        ;

    // -- c_compiler

    Constructor c_compiler.create_compiler;
      begin
        Inherited Create;
      end; // create_compiler

    procedure c_compiler.compile(p_file_name: String; p_c_output: tStrings);
      var l_c_scanner: c_scanner;
          l_c_parser: c_parser;
          l_c_instruction_list: c_instruction_list;
          l_c_variable_list: c_variable_list;
          l_c_interpreter: c_interpreter;
      begin
        l_c_scanner:= c_scanner.create_scanner('scanner', p_file_name);

        with l_c_scanner do
        begin
          if f_load
            then begin
                l_c_parser:= c_parser.create_parser('parser');

                l_c_instruction_list:= c_instruction_list.create_instruction_list('instr');
                l_c_parser.parse(l_c_scanner, l_c_instruction_list);

                l_c_variable_list:= c_variable_list.create_variable_list('var');

                l_c_interpreter:= c_interpreter.create_interpreter;
                l_c_interpreter.interpret(l_c_instruction_list, l_c_variable_list);

                l_c_variable_list.display_variable_list;
              end
            else display('could_not_find');

          Free;
        end; // with l_c_scanner
      end; // compile

    Destructor c_compiler.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_compiler
    end. // u_c_compiler
