// 005 u_c_variable_list_15
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

// -- a tStringList with an attached ^element

(*$r+*)

unit u_c_variable_list_15;
  interface
    uses Classes, u_c_basic_object;

    type t_Integer= Integer;

         c_variable_list= // "variable" list
                          Class(c_basic_object)
                            m_c_variable_list: tStringList;

                            Constructor create_variable_list(p_name: String);

                            function f_variable_count: Integer;
                            function f_Integer(p_variable_index: Integer): t_Integer;
                            function f_index_of(p_variable: String): Integer;
                            function f_find_by_variable(p_variable: String): t_Integer;
                            procedure add_variable(p_variable: String; p_Integer: t_Integer);
                            procedure add_unique_variable(p_variable: String; p_Integer: t_Integer);

                            procedure set_value(p_variable_index: Integer; p_variable_value: t_Integer);

                            procedure display_variable_list;

                            Destructor Destroy; Override;
                          end; // c_variable_list

  implementation
    uses SysUtils, u_c_display;

    // -- c_variable_list

    Constructor c_variable_list.create_variable_list(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_variable_list:= tStringList.Create;
      end; // create_variable_list

    function c_variable_list.f_variable_count: Integer;
      begin
        Result:= m_c_variable_list.Count;
      end; // f_variable_count

    function c_variable_list.f_Integer(p_variable_index: Integer): t_Integer;
      begin
        Result:= t_Integer(m_c_variable_list.Objects[p_variable_index]);
      end; //  f_Integer

    procedure c_variable_list.set_value(p_variable_index: Integer; p_variable_value: t_Integer);
      begin
        m_c_variable_list.Objects[p_variable_index]:= tObject(p_variable_value);
      end; // set_value

    function c_variable_list.f_index_of(p_variable: String): Integer;
      begin
        Result:= m_c_variable_list.IndexOf(p_variable);
      end; // f_index_of

    function c_variable_list.f_find_by_variable(p_variable: String): t_Integer;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_variable);
        if l_index_of< 0
          then Result:= 0
          else Result:= t_Integer(m_c_variable_list.Objects[l_index_of]);
      end; // f_find_by_variable

    procedure c_variable_list.add_variable(p_variable: String; p_Integer: t_Integer);
      begin
        display('add_var >'+ p_variable+ '<');
        m_c_variable_list.AddObject(p_variable, tObject(p_Integer));
      end; // add_variable

    procedure c_variable_list.add_unique_variable(p_variable: String; p_Integer: t_Integer);
      begin
        if f_index_of(p_variable)>= 0
          then
          else add_variable(p_variable, p_Integer);
      end; // add_unique_variable

    procedure c_variable_list.display_variable_list;
      var l_variable_index: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_variable_count));

        for l_variable_index:= 0 to f_variable_count- 1 do
          display(Format('  %-15s %5d', [m_c_variable_list[l_variable_index], f_integer(l_variable_index)]));
      end; // display_variable_list

    Destructor c_variable_list.Destroy;
      var l_variable_index: Integer;
      begin
        m_c_variable_list.Free;

        Inherited;
      end; // Destroy

    begin // u_c_variable
    end. // u_c_variable
